#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{

    [Description("Enter the description of your new custom indicator here")]
    public class EMADaily : Indicator
    {
        #region Variables
 
            private int period = 20; 
		
// Internas
		
		
    
        #endregion


        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Red), PlotStyle.Line, "Plot0"));
			Plots[0].Pen.Width=2;
            Overlay				= true;
			Add(PeriodType.Day,1);
			
        }


        protected override void OnBarUpdate()
        {
			
		if (CurrentBar < period*144)	return;
	
		Plot0.Set(EMA(BarsArray[1],period)[0]);
			
        }

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Plot0
        {
            get { return Values[0]; }
        }

        [Description("")]
        [GridCategory("Parameters")]
        public int Period
        {
            get { return period; }
            set { period = Math.Max(1, value); }
        }
		
        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private EMADaily[] cacheEMADaily = null;

        private static EMADaily checkEMADaily = new EMADaily();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public EMADaily EMADaily(int period)
        {
            return EMADaily(Input, period);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public EMADaily EMADaily(Data.IDataSeries input, int period)
        {
            if (cacheEMADaily != null)
                for (int idx = 0; idx < cacheEMADaily.Length; idx++)
                    if (cacheEMADaily[idx].Period == period && cacheEMADaily[idx].EqualsInput(input))
                        return cacheEMADaily[idx];

            lock (checkEMADaily)
            {
                checkEMADaily.Period = period;
                period = checkEMADaily.Period;

                if (cacheEMADaily != null)
                    for (int idx = 0; idx < cacheEMADaily.Length; idx++)
                        if (cacheEMADaily[idx].Period == period && cacheEMADaily[idx].EqualsInput(input))
                            return cacheEMADaily[idx];

                EMADaily indicator = new EMADaily();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Period = period;
                Indicators.Add(indicator);
                indicator.SetUp();

                EMADaily[] tmp = new EMADaily[cacheEMADaily == null ? 1 : cacheEMADaily.Length + 1];
                if (cacheEMADaily != null)
                    cacheEMADaily.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheEMADaily = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EMADaily EMADaily(int period)
        {
            return _indicator.EMADaily(Input, period);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.EMADaily EMADaily(Data.IDataSeries input, int period)
        {
            return _indicator.EMADaily(input, period);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.EMADaily EMADaily(int period)
        {
            return _indicator.EMADaily(Input, period);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.EMADaily EMADaily(Data.IDataSeries input, int period)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.EMADaily(input, period);
        }
    }
}
#endregion
