// 
// Copyright (C) 2006, NinjaTrader LLC <www.ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Indicator;
using NinjaTrader.Strategy;
#endregion


// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    /// <summary>
    /// This is a sample multi-time frame strategy.
    /// </summary>
    [Description("This is a sample multi-time frame strategy.")]
    public class MultiTimeFrame : Strategy
    {
        #region Variables
   private int emaperiodo=5;
        #endregion


        protected override void Initialize()
        {
           
			Add(PeriodType.Day, 1);// Añado un Dataseries diario
			Add(EMADaily(emaperiodo));
			
			
            CalculateOnBarClose = true;
        }

        protected override void OnBarUpdate()
        {

			if (CurrentBar < emaperiodo)	return;
			if (BarsInProgress != 0)
				return;
			
			
			if (Bars.FirstBarOfSession)
			{
				if (Close[0]>EMA(BarsArray[1], emaperiodo)[0])
				{
					EnterLong();
					
				}
				
					if (Close[0]<EMA(BarsArray[1], emaperiodo)[0])
				{
					EnterShort();
				}
			}
			
			
		}
			


        #region Properties
		
				[Description("")]
        [Category("Parameters")]
        public int Emaperiodo
        {
            get { return emaperiodo; }
            set { emaperiodo = Math.Max(1, value); }
        }
        #endregion
    }
}
